unit URozhrani;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ColorGrd, ExtCtrls, Buttons, ExtDlgs, StdCtrls, ComCtrls,
  ToolWin, Menus, ImgList,UVoronoi, TabNotBk, Spin,UUzelGeneratorHrana,UAStar;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
     File1: TMenuItem;
      New1: TMenuItem;
      Open1: TMenuItem;
      OpenDialog1: TOpenDialog;
      Save1: TMenuItem;
      SaveDialog1: TSaveDialog;
      Close1: TMenuItem;
     Help1: TMenuItem;
      About1: TMenuItem;
    PaintBox1: TPaintBox;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
     SpeedButton1: TSpeedButton;
     SpeedButton3: TSpeedButton;
     SpeedButton4: TSpeedButton;
     SpeedButton5: TSpeedButton;
     Label3: TLabel;
     Label4: TLabel;
     SpinEdit1: TSpinEdit;
     SpinEdit2: TSpinEdit;
     ToolButton1: TToolButton;
     ToolButton2: TToolButton;
     ToolButton3: TToolButton;
     ToolButton4: TToolButton;
     ToolButton5: TToolButton;
     ToolButton6: TToolButton;
     ToolButton7: TToolButton;
     ToolButton8: TToolButton;

  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure ToolBar1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure PointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure StartPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure TargetPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure InsPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure PaintBox1Paint(Sender: TObject);
  procedure New1Click(Sender: TObject);
  procedure Save1Click(Sender: TObject);
  procedure Open1Click(Sender: TObject);
  procedure Close1Click(Sender: TObject);
  procedure About1Click(Sender: TObject);
  procedure SpeedButton1Click(Sender: TObject);
  procedure SpeedButton5Click(Sender: TObject);
  procedure SpeedButton3Click(Sender: TObject);
  procedure SpeedButton4Click(Sender: TObject);
  procedure Vymaz;

  function SaveFile:Boolean;
  function OpenFile:Boolean;

  private
    { Private declarations }
     SpBtn1Aktivni, SpBtn3Aktivni, SpBtn4Aktivni: Boolean;
     Vykresleni, Zmeneno: Boolean;
     LevyKlik: Integer;
     Voronoi: TVoronoiDiagram;
     Astar: TAStar;
  public
    { Public declarations }
end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//FormCreate

procedure TForm1.FormCreate(Sender: TObject);
begin
  Voronoi:= TVoronoiDiagram.Create;
  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*0.5)),Round((10000*((3*(sqrt(2)))/2+0.5)))));
  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(-Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
  SpeedButton1Click(nil);
  LevyKlik:=0;
  Vykresleni:=False;
  Zmeneno:=False;
end;

//FormDestroy

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Voronoi.Free;
  Astar.Free;
end;

procedure TForm1.ToolBar1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Tool bar ';
end;

procedure TForm1.PointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Pomoc tohoto tlatka vlote bod ';
end;

procedure TForm1.StartPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Pomoc tohoto tlatka vlote Start ';
end;

procedure TForm1.TargetPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Pomoc tohoto tlatka vlote Cl ';
end;

procedure TForm1.InsPointMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Pomoc tohoto tlatka vlote bod ';
end;

procedure TForm1.StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[1].Text:= ' Status bar';
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[2].Text:= ' x : '+ IntToStr(X);
  StatusBar1.Panels[3].Text:= ' y : '+ IntToStr(Y);
  StatusBar1.Panels[1].Text:= ' Paint box ';
  PaintBox1.Canvas.Pen.Mode := pmcopy;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Zmeneno:=True;
  If SpBtn1Aktivni then Voronoi.VytvorPolygon(Voronoi.PridejGenerator(X,Y));
  If SpBtn3Aktivni then
    Begin
      Voronoi.StartBod:=TUzel.Create(X,Y);
      Voronoi.Uzly.Add(Voronoi.StartBod);
      PaintBox1.Repaint;
      SpeedButton4.Enabled:=True;
      SpeedButton3.Enabled:=False;
      SpBtn3Aktivni:=False;
    end;
 If SpBtn4Aktivni then
  Begin
    Voronoi.CilBod:=TUzel.Create(X,Y);
    Voronoi.Uzly.Add(Voronoi.CilBod);
    Voronoi.PropojBody;
    PaintBox1.Repaint;
    SpeedButton4.Enabled:=False;
    SpBtn4Aktivni:=False;
      If (Voronoi.StartBod<>nil) and (Voronoi.CilBod<>nil) then Astar:=TAStar.Create(Voronoi.StartBod,Voronoi.CilBod);
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Voronoi.PrekresliHrany;
  Voronoi.PrekresliVsechnyGeneratory;
  Voronoi.PrekresliStartBod;
  Voronoi.PrekresliCilBod;
  if (Astar is TAStar) then Astar.VykresliCestu;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  SpeedButton1.Enabled:=True;
  SpeedButton1.Font.Color:=ClGreen;

  SpeedButton3.Enabled:=True;
  SpeedButton3.Font.Color:=ClRed;

  SpeedButton4.Enabled:=False;
  SpeedButton4.Font.Color:=ClRed;

  SpBtn1Aktivni:=True;
  SpBtn3Aktivni:=False;
  SpBtn4Aktivni:=False;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  PaintBox1MouseDown(nil,mbLeft,[ssLeft],SpinEdit1.Value,SpinEdit2.Value);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  SpeedButton1.Enabled:=False;
  SpeedButton1.Font.Color:=clRed;

  SpeedButton3.Enabled:=True;
  SpeedButton3.Font.Color:=ClGreen;

  SpeedButton4.Enabled:=False;
  SpeedButton4.Font.Color:=ClRed;

  SpeedButton5.Enabled:=False;

  SpBtn1Aktivni:=False;
  SpBtn3Aktivni:=True;
  SpBtn4Aktivni:=False;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  SpeedButton1.Enabled:=False;
  SpeedButton1.Font.Color:=clRed;

  SpeedButton3.Enabled:=False;
  SpeedButton3.Font.Color:=ClGreen;

  SpeedButton4.Enabled:=True;
  SpeedButton4.Font.Color:=ClGreen;

  SpeedButton5.Enabled:=False;

  SpBtn1Aktivni:=False;
  SpBtn3Aktivni:=False;
  SpBtn4Aktivni:=True;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  SpeedButton5.Enabled:=True;
  If Zmeneno then
    Case MessageDlg('Save change?', mtWarning, mbYesNoCancel, 0)of
      mrYes : Begin
                If SaveFile then
              Begin
                Voronoi.Free;
                Astar.Free;
                Astar:=nil;
                Voronoi:=TVoronoiDiagram.Create;
                PaintBox1.Repaint;
              Try
                Try
                  Screen.Cursor:=crHourGlass;
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*0.5)),Round((10000*((3*(sqrt(2)))/2+0.5)))));
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(-Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
                  SpeedButton1Click(nil);
                  LevyKlik:=0;
                  Vykresleni:=False;
                  Zmeneno:=False;
                except
                  Voronoi.Free;
                end;
                finally
                  Screen.Cursor:=CrDefault;
              end;
             end;
            end;

      mrNo : Begin
               Voronoi.Free;
               Astar.Free;
               Astar:=nil;
               Voronoi:=TVoronoiDiagram.Create;
               PaintBox1.Repaint;
              Try
                Try
                  Screen.Cursor:=crHourGlass;
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*0.5)),Round((10000*((3*(sqrt(2)))/2+0.5)))));
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(-Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
                  Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
                  SpeedButton1Click(nil);
                  LevyKlik:=0;
                  Vykresleni:=False;
                  Zmeneno:=False;
                except
                  Voronoi.Free;
                end;
              finally
                Screen.Cursor:=CrDefault;
              end;
             end;
  end
    else
  begin
    Voronoi.Free;
    Astar.Free;
    Astar:=nil;
    Voronoi:=TVoronoiDiagram.Create;
    PaintBox1.Repaint;
      Try
        Try
          Screen.Cursor:=crHourGlass;
          Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*0.5)),Round((10000*((3*(sqrt(2)))/2+0.5)))));
          Voronoi.VytvorPolygon(Voronoi.PridejGenerator(-Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
          Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
          SpeedButton1Click(nil);
          LevyKlik:=0;
          Vykresleni:=False;
          Zmeneno:=False;
        except
          Voronoi.Free;
        end;
        finally
          Screen.Cursor:=CrDefault;
        end;
      end;
  end;

Function TForm1.SaveFile:Boolean;
  var
    t: TextFile;
    s, text: string;
    i: integer;
  Begin
    Result:=False;
    GetDir(0,s);
    Form1.SaveDialog1.InitialDir:=s;
    if not Form1.SaveDialog1.Execute then exit;
    AssignFile(t, Form1.SaveDialog1.FileName);
    rewrite(t);
    for i:=0 to Voronoi.Generatory.Count-1 do
      begin
        text:='G';
        writeln(t, text);
        text:=IntToStr(TGenerator(Voronoi.Generatory.Items[i]).x);
        writeln(t,text);
        text:=IntToStr(TGenerator(Voronoi.Generatory.Items[i]).y);
        writeln(t,text);
      end;
    CloseFile(t);
    Result:=True;
end;

Function TForm1.OpenFile:Boolean;
  var
    t: TextFile;
    s: String;
    X,Y:Integer;
    Begin
      Result:=False;
      GetDir(0,s);
      OpenDialog1.InitialDir:=s;
      if not OpenDialog1.Execute then exit;
      AssignFile(t, OpenDialog1.Filename);
      Reset(t);
      Try
        Screen.Cursor:=crHourGlass;
        while not eof(t) do
          begin
            readln(t,s);
            If s = 'G' then
              Begin
                readln(t,s);
                X:=StrToInt(s);
                readln(t,  s);
                Y:=StrToInt(s);
                Voronoi.VytvorPolygon(Voronoi.PridejGenerator(X,Y));
              end;
          end;
      finally
        Screen.Cursor:=crDefault;
      end;
    PaintBox1.Repaint;
    CloseFile(t);
    Result:=True;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  SaveFile;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  If Zmeneno then
  Begin
    Case MessageDlg('Save change?',mtWarning,mbYesNoCancel,0) of
    mrYes : Begin If SaveFile then
              Begin
              Vymaz;
              If OpenFile = false then
              Begin
               Try
                screen.Cursor:=crHourGlass;
                Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*0.5)),Round((10000*((3*(sqrt(2)))/2+0.5)))));
                Voronoi.VytvorPolygon(Voronoi.PridejGenerator(-Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
                Voronoi.VytvorPolygon(Voronoi.PridejGenerator(Round((10000*((3*(sqrt(6)))/4+0.5))),-Round((10000*((3*(sqrt(2)))/4+0.5)))));
               finally
                screen.Cursor:=crDefault;
               end;
              end;
             end;
            end;
    mrNo :  Begin Vymaz;
              If OpenFile then
              Zmeneno:=False;
            end;
    end;
  end
  else
    Begin
      Vymaz;
      OpenFile;
    end;
      SpeedButton1Click(nil);
end;

procedure TForm1.Vymaz;
Begin
  Voronoi.Free;
  Astar.Free;
  Astar:=nil;
  Voronoi:=TVoronoiDiagram.Create;
  PaintBox1.Repaint;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  MessageDlg('Voronoi diagram, VUT FSI 2009', mtInformation, [mbOK], 0);
end;

end.
