unit UUzelGeneratorHrana;

interface
 uses
  Classes,Types;

 type
  THrana = class;

  TGenerator = class(TObject)

   private
    Fx,Fy: Int64;
    FHrany: TList;
    procedure SetFx(aFx: Int64);
    procedure SetFy(aFy: Int64);

   public
    constructor Create(aX,aY: Int64);
    destructor Destroy; override;
    property X: Int64 read Fx write SetFx;
    property Y: Int64 read Fy write SetFy;
    property Hrany: TList read FHrany write FHrany;
  end;

  TUzel = class(TObject)

   private
    Fx,Fy: Double;
    FPredchudce: TUzel;
    FOhodnoceni, FVzdalenostKPrvnimu: Single;
    SeznamHran: TList;

   public
    constructor Create(aX,aY: Double);
    destructor Destroy; override;
    property X: Double read Fx write Fx;
    property Y: Double read Fy write Fy;
    property Ohodnoceni: Single read FOhodnoceni write FOhodnoceni;
    property Predchudce: TUzel read Fpredchudce write Fpredchudce;
    property Hrany: TList read SeznamHran;
    property VKPrvnimu: Single read FVzdalenostKPrvnimu write FVzdalenostKPrvnimu;
  end;

  THrana = class(TObject)

   private
    FUzel1,FUzel2: TUzel;
    FGenerator1,FGenerator2: TGenerator;
    FOhodnoceni: Double;
    procedure SetUzel1(aUzel: TUzel);
    procedure SetUzel2(aUzel: TUzel);
    procedure SetOhodnoceni(aOhodnoceni: Double);

   public
    constructor Create(aUzel1,aUzel2: TUzel; aGenerator1,aGenerator2: TGenerator);
    destructor Destroy; override;
    property Uzel1: TUzel read FUzel1 write SetUzel1;
    property Uzel2: TUzel read FUzel2 write SetUzel2;
    property Generator1: TGenerator read FGenerator1;
    property Generator2: TGenerator read FGenerator2;
    property Ohodnoceni: Double read FOhodnoceni write SetOhodnoceni;
 end;

  TPrusecik = class(TUzel)

   private
    FHrana: THrana;

   public
    property Hrana: THrana read FHrana write FHrana;
    constructor Create(aX,aY: Double; aHrana: THrana);
    destructor Destroy; override;
  end;

implementation
  uses Uvoronoi;

  Constructor TGenerator.Create(aX,aY:Int64);
   Begin
    Inherited Create;
    X:= aX;
    Y:= aY;
    FHrany:= TList.Create;
   end;

  Procedure TGenerator.SetFx(aFx:Int64);
   Begin
    Fx:=aFx;
   end;

  Procedure TGenerator.SetFy(aFy:Int64);
   Begin
    Fy:=aFy;
   end;

  Destructor TGenerator.Destroy;
   Begin
    Inherited Destroy;
   end;

  Constructor THrana.Create(aUzel1,aUzel2:TUzel;aGenerator1,aGenerator2:TGenerator);
   Begin
    Inherited Create;
    Uzel1:=aUzel1;
    Uzel2:=aUzel2;
    FGenerator1:=aGenerator1;
    FGenerator2:=aGenerator2;
    Ohodnoceni:=0;
   end;

  Destructor THrana.Destroy;
   Begin
    Inherited Destroy;
   end;

  Constructor TUzel.Create(aX,aY:Double);
   Begin
    Inherited Create;
    X:=aX;
    Y:=aY;
    Ohodnoceni:=Nekonecno;
    SeznamHran:=TList.Create;
    FPredchudce:=nil;
   end;

  Destructor TUzel.Destroy;
   Begin
    SeznamHran.Free;
    Inherited Destroy;
   end;

  Constructor TPrusecik.Create(aX,aY:Double;aHrana:THrana);
   Begin
    Inherited Create(aX,aY);
    FHrana:=aHrana;
   end;

  Destructor TPrusecik.Destroy;
   Begin
    FHrana:=nil;
    Inherited Destroy;
   end;

  Procedure THrana.SetUzel1(aUzel:TUzel);
   Begin
    If aUzel <> nil then
     FUzel1:=aUzel;
   end;

  Procedure THrana.SetUzel2(aUzel:TUzel);
   Begin
    If aUzel <> nil then
     FUzel2:=aUzel;
   end;

  Procedure THrana.SetOhodnoceni(aOhodnoceni:Double);
   Begin
   If aOhodnoceni >=0 then
   FOhodnoceni:=aOhodnoceni
   else
   FOhodnoceni:=0;
   end;

end.
